\documentclass{article}
\usepackage[
  paperwidth = \figurewidth, paperheight = \figureheight, offset = 0pt,
  margin = 0pt, textwidth = \paperwidth, textheight = \paperheight, noheadfoot,
  nomarginpar
]{geometry}
\usepackage{tikz}
\usetikzlibrary{patterns, patterns.meta, arrows.meta}
% Sparse matrix fill pattern
\pgfdeclarepatternformonly{sparse}{
  \pgfqpoint{-5pt}{-5pt}
}{
  \pgfqpoint{14pt}{14pt}
}{
  \pgfqpoint{18pt}{18pt}
}
{
  \pgfpathcircle{\pgfqpoint{0pt}{0pt}}{2pt}
  \pgfpathcircle{\pgfqpoint{9pt}{9pt}}{2pt}
  \pgfusepath{fill}
}
% Fill pattern for sparse matrices with fill-in
\pgfdeclarepatternformonly{fillin}{
  \pgfqpoint{-3pt}{-3pt}
}{
  \pgfqpoint{12pt}{12pt}
}{
  \pgfqpoint{16pt}{16pt}
}
{
  \pgfpathcircle{\pgfqpoint{0pt}{0pt}}{3pt}
  \pgfpathcircle{\pgfqpoint{7pt}{7pt}}{3pt}
  \pgfusepath{fill}
}
% Dense matrix fill pattern
\pgfdeclarepatternformonly{dense}{
  \pgfqpoint{-3pt}{-3pt}
}{
  \pgfqpoint{3pt}{3pt}
}{
  \pgfqpoint{6pt}{6pt}
}
{
  \pgfpathcircle{\pgfqpoint{0pt}{0pt}}{3pt}
  \pgfusepath{fill}
}
% Compressed matrix pattern
\pgfdeclarepattern{
  name = compressed,
  bottom left = {\pgfpoint{-.1pt}{-.1pt}},
  top right = {\pgfpoint{10.1pt}{10.1pt}},
  tile size = {\pgfpoint{10pt}{10pt}},
  tile transformation = {\pgftransformrotate{21}},
  code = {
    \pgfsetlinewidth{0.5pt}
    \pgfpathmoveto{\pgfpoint{-0.1pt}{-0.1pt}}
    \pgfpathlineto{\pgfpoint{10.1pt}{10.1pt}}
    \pgfpathmoveto{\pgfpoint{-.1pt}{10.1pt}}
    \pgfpathlineto{\pgfpoint{10.1pt}{-.1pt}}
    \pgfusepath{stroke}
  }
}
% Global scaling parameters and dimensions
\def\drawscale{4.5}
\def\labelscale{3}
\def\labelinnersep{0.5ex}
\def\labellinewidth{0.2mm}
\def\sidelinewidth{1.8mm}
\def\matrixinnersep{2.25ex}
\def\matrixlinewidth{1mm}
\def\submatrixlinewidth{0.5mm}
% Custom color definitions
\usepackage{xcolor}
\definecolor{brokensymmetry}{RGB}{0, 128, 128}
\definecolor{density}{RGB}{255, 102, 0}
\definecolor{repetition}{RGB}{128, 0, 128}
